"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _types = require("@babel/types");

var _optionsDefaults = _interopRequireDefault(require("./schemas/optionsDefaults"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const createSpreadMapper = (path, stats) => {
  const result = {};
  let {
    attributeNames
  } = _optionsDefaults.default;

  if (stats.opts && stats.opts.attributeNames) {
    attributeNames = _objectSpread(_objectSpread({}, attributeNames), stats.opts.attributeNames);
  }

  const attributes = Object.entries(attributeNames).filter(pair => {
    return pair[1];
  });
  const attributeKeys = attributes.map(pair => {
    return pair[0];
  });
  const spreadAttributes = path.node.openingElement.attributes.filter(attribute => {
    return (0, _types.isJSXSpreadAttribute)(attribute);
  });

  for (const spread of spreadAttributes) {
    for (const attributeKey of attributeKeys) {
      const destinationName = attributeNames[attributeKey];

      if (result[destinationName]) {
        result[destinationName] = (0, _types.binaryExpression)('+', result[destinationName], (0, _types.conditionalExpression)((0, _types.cloneNode)(spread.argument), (0, _types.binaryExpression)('+', (0, _types.stringLiteral)(' '), (0, _types.logicalExpression)('||', (0, _types.memberExpression)((0, _types.cloneNode)(spread.argument), (0, _types.identifier)(destinationName)), (0, _types.stringLiteral)(''))), (0, _types.stringLiteral)('')));
      } else {
        result[destinationName] = (0, _types.conditionalExpression)((0, _types.cloneNode)(spread.argument), (0, _types.logicalExpression)('||', (0, _types.memberExpression)((0, _types.cloneNode)(spread.argument), (0, _types.identifier)(destinationName)), (0, _types.stringLiteral)('')), (0, _types.stringLiteral)(''));
      }
    }
  }

  return result;
};

var _default = createSpreadMapper;
exports.default = _default;
//# sourceMappingURL=createSpreadMapper.js.map